.. fir_filter_symmetric_xs documentation

.. This file is protected by Copyright. Please refer to the COPYRIGHT file
   distributed with this source distribution.

   This file is part of OpenCPI <http://www.opencpi.org>

   OpenCPI is free software: you can redistribute it and/or modify it under the
   terms of the GNU Lesser General Public License as published by the Free
   Software Foundation, either version 3 of the License, or (at your option) any
   later version.

   OpenCPI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
   A PARTICULAR PURPOSE. See the GNU Lesser General Public License for
   more details.

   You should have received a copy of the GNU Lesser General Public License
   along with this program. If not, see <http://www.gnu.org/licenses/>.


.. _fir_filter_symmetric_xs:


FIR Filter Symmetric (``fir_filter_symmetric_xs``)
==================================================
A FIR filter implementation which makes use of the symmetry in the taps to allow a more efficient implementation.

Design
------
A symmetric FIR filter is a specialised case of FIR filter design, where the filter coefficients are reflected around the central coefficient. This symmetry allows for efficiencies where only half the number of multiplications are required.

A generic N tap FIR Filter with no symmetry can be expressed as:

.. _symmetric_fir_general_FIR-equation:

.. math::
   :label: General_FIR-equation

   y[n]=\sum_{k=0}^{N-1}h[k]x[n-k]

In :eq:`General_FIR-equation`:

 * :math:`y[n]` is the output values.

 * :math:`x[n]` is the input values.

 * :math:`N` is the total number of taps.

 * :math:`h[k]` is the taps values, from :math:`0` to :math:`N - 1`.

If the N taps are symmetric the generalized equation for the output :math:`y` of a symmetric FIR with an odd number of taps, :math:`N`, is expressed as:

.. math::
   :label: fir_filter_symmetric-odd-equation

   y[n] = \left( \sum_{k=0}^{\frac{N}{2}-1} h[k] \times (x[n-k] + x[n-((N - 1)-k)]) \right) + h[\frac{N-1}{2}] \times x[n-\frac{N-1}{2}]


The :eq:`fir_filter_symmetric-odd-equation`, results in the folding of :math:`h(k)` taps around :math:`N/2`, resulting in half the multiplications and additions that would have been required by :eq:`General_FIR-equation`. A block diagram representation of the :eq:`fir_filter_symmetric-odd-equation` is given in the :numref:`symmetric_fir_odd_taps-diagram` below.

.. _symmetric_fir_odd_taps-diagram:

.. figure:: symmetric_fir.svg
   :alt: Block diagram showing symmetric FIR structure.
   :align: center

   Symmetric FIR filter odd tap implementation.

Depending on the definable ``number_of_taps`` property the exact reflection around the central tap(s) is different. If the N taps are symmetric and the ``number_of_taps`` is even then the generalized equation for the output :math:`y`, is expressed as:

.. math::
   :label: fir_filter_symmetric-even-equation

   y[n] = \sum_{k=0}^{\frac{N}{2}-1} h[k] \times (x[n-k] + x[n-((N - 1)-k)])

A block diagram representation of the even implementation is given in :numref:`symmetric_fir_even_taps-diagram` below.

.. _symmetric_fir_even_taps-diagram:

.. figure:: symmetric_fir_even_taps.svg
   :alt: Block diagram of a symmetric finite impulse response (FIR) filter implementation
   :align: center

   Symmetric FIR filter even tap implementation.

As the calculation involves rounding, there is a choice of rounding types that can be selected via the ``rounding_type`` property. The application should choose between half-up, half-even or truncation to minimise any bias. The truncation also has a choice to saturate the output generated by the component to the maximum or minimum value defined by the output type (e.g. -32,768 to 32,767 for short values). This can be achieved by using the ``truncate_with_saturation`` value.

Interface
---------
.. literalinclude:: ../specs/fir_filter_symmetric_xs-spec.xml
   :language: xml
   :lines: 1,19-

Opcode Handling
~~~~~~~~~~~~~~~

   * Samples

      * Apply the samples to the FIR cascade structure

      * Send the calculated samples to the output port.

   * Time

      * The time is decremented by the ``group_delay`` before forwarding to the output port.

   * Sample_Interval

      * The input sample interval forwarded to output port.

   * Flush

      * If there is data within the filter, input ``number_of_taps`` zeros into the sample buffer, outputting any samples generated.

      * Forward to output port.

   * Discontinuity

      * Reset history buffer

      * Forward to output port.

   * Metadata

      * Forward to output port.


Properties
~~~~~~~~~~
.. ocpi_documentation_properties::

Note: Given :math:`h(k)` symmetric taps that can folded around :math:`N/2`, the component only needs to use half the supplied taps. The component uses the last half of the supplied tap arrays, and assumes it is symmetric with the first half.


Ports
~~~~~
.. ocpi_documentation_ports::

   input: Primary input samples port.
   output: Primary output samples port.

Implementations
---------------

.. ocpi_documentation_implementations:: ../fir_filter_symmetric_xs.hdl ../fir_filter_symmetric_xs.rcc

Example Application
-------------------
.. literalinclude:: example_app.xml
   :language: xml
   :lines: 1,19-

Dependencies
------------
.. ocpi_documentation_include:: ../doc/fir_filter_symmetric/dependencies.inc

   |primitive_name|: Protocol interface delay primitive v2
   |primitive_link|: protocol_interface_delay_v2-primitive

Limitations
-----------
.. ocpi_documentation_include:: ../doc/fir_filter_symmetric/limitations.inc

   |component_name|: fir_filter_symmetric_xs

The HDL and RCC implementations require `number of taps` to be any positive number.

Taps must be symmetrical.

Testing
-------
.. ocpi_documentation_test_platforms::

.. ocpi_documentation_test_result_summary::
